
program mami;

{==========================================================================
    Cm: mami
  Trgy: makeindex pre- s posztprocesszor a LaTeX-hez, a magyar betrendbe
         sorols megvalstshoz
 Szerz: Nmeth Lszl <nemethl@sol.cc.u-szeged.hu>
  Dtum: 1998.05.28. 
 Verzi: 2.01 (1998.12.17.)
===========================================================================}

uses Dos;

{ ************************************************************** }

type
  Allapot = Byte;
  Allapothalmaz = set of Allapot;
  FeliratTipus = (NINCS, KISBETUS, NAGYBETUS, NAGYONNAGY);

{ ************************************************************** }

const
  Verzio = 'Ez a mami, a portabilis 2.0 verzio. [1998.12.15]';
  Fejlec = 'mami [-?]  [-1 | -2 | -3] [-s stilusfajl] [idx allomany | in2 allomany]';
  Sugo = 'magyar makeindex pre- es posztprocesszor'^M^J +
         '  -s stilusfajl -> lasd: man makeindex  '^M^J +
         '  -1 kisbetus cimkek a beturendben  (cs)'^M^J +
         '  -2 nagybetus cimkek a beturendben (Cs)'^M^J +
         '  -3 nagyon nagybetus cimkek        (CS)'^M^J;
  makename = {$IFDEF LINUX} 'makeindex' {$ELSE} 'MAKEINDX.EXE' {$ENDIF};


{ ************************************************************** }

type
 opciok = (group_skip, heading_prefix, heading_suffix);
	   
const
 opcio: array[opciok] of String = (
    #13#10#13#10 + ' \indexspace' + #13#10, '', '');
 opcio_txt: array[opciok] of String[14] = ( 
    'group_skip', 'heading_prefix', 'heading_suffix');
  
{ ************************************************************** }

  KodJel = 'Q'; Kodjel2 = 'q';
  Kodsorozat = KodJel + KodJel + KodJel;
  { Ha a kdsorozatban az
      1. bet nagy: nagy bet, ha kicsi : kis bet a kdolt bet
      2. bet nagy: >>kettzott<< tbbjegy mssalhangz, ha kicsi : nem
      3. bet nagy: Ha tbbjegy mssalhangz, akkor nem ,,nagyon nagy''
                    Ha nem tbbjegy mssalhangz, akkor rvid magnhangz
             kicsi: Ha tbbjegy mssalhangz, akkor ,,nagyon nagy'',
                    ha nem tbbjegy mssalhangz, akkor hossz magnhangz
  }
  OsszesBetu = (40 + 4) * 2 + 9 * 3;
  Felirat: FeliratTipus = NINCS;
  LaTeXABC: array [0 .. OsszesBetu] of String[12] =
   { Magyar kisbetk + qwxy }
    ('', 'a','\''a', 'b', 'c', 'cs', 'd', 'dz', 'dzs', 'e', '\''e', 'f',
      'g', 'gy', 'h', 'i', '\IeC {\''\i }', 'j', 'k', 'l', 'ly', 'm', 'n',
      'ny', 'o', '\''o', '\"o', '\H o', 'p', 'q', 'r', 's', 'sz', 't',
      'ty', 'u', '\''u', '\"u', '\H u', 'v', 'w', 'x', 'y', 'z', 'zs',
   { Magyar nagybetk + QWXY }
      'A', '\''A', 'B', 'C', 'Cs', 'D', 'Dz', 'Dzs', 'E', '\''E', 'F',
      'G', 'Gy', 'H', 'I', '\''I', 'J', 'K', 'L', 'Ly', 'M', 'N',
      'Ny', 'O', '\''O', '\"O', '\H O', 'P', 'Q', 'R', 'S', 'Sz', 'T',
      'Ty', 'U', '\''U', '\"U', '\H U', 'V', 'W', 'X', 'Y', 'Z', 'Zs',
    { Magyar tobbjegyu betuk ,,nagyon'' nagy valtozatai }
      'CS', 'DZ', 'DZS', 'GY', 'LY', 'NY', 'SZ', 'TY', 'ZS',
    { Magyar tobbjegyu betuk kettozott valtozatai }
      'ccs', 'ddz', 'ddzs', 'ggy', 'lly', 'nny', 'ssz', 'tty', 'zzs',
      'CCS', 'DDZ', 'DDZS', 'GGY', 'LLY', 'NNY', 'SSZ', 'TTY', 'ZZS');

  TobbjegyubolSima: array [89 .. OsszesBetu] of Char =
    (#131, #133, #134, #139, #146, #149, #158, #160, #170,
     #131, #133, #134, #139, #146, #149, #158, #160, #170,
     #131, #133, #134, #139, #146, #149, #158, #160, #170);

  KisBetuk: Allapothalmaz = [1 .. 44];
  SimaABC: Allapothalmaz = [1 .. 44 * 2];
  NagyonNagySimaTobbjegyu: Allapothalmaz = [89 .. 88 + 9];
  SimaKettozott: Allapothalmaz = [89 + 9 .. 88 + 18];
  NagyonNagyKettozott: Allapothalmaz = [89 + 18 .. OsszesBetu];
  TobbjegyuMassalhangzok: Allapothalmaz = [5, 7, 8, 13, 20, 23, 32, 34, 44,
                                           49, 51, 52, 57, 64, 67, 76, 78,
                                           88 .. OsszesBetu];
  KettozottTobbjegyuek: Allapothalmaz = [89 + 9 .. OsszesBetu];
  HosszuMaganhangzok: Allapothalmaz = [ 2, 10, 16, 25, 27, 36, 38,
                                       46, 54, 60, 69, 71, 80, 82];
  AlapAllapot = OsszesBetu + 1;
  ParancsAllapot = OsszesBetu + 2;
  ASCIIfelso = 126;

{ ************************************************************** }

var
  Bemenet, Kimenet : Text;
  A: Allapot;
  Dir: DirStr;
  Nev: NameStr;
  Kiterj: ExtStr;
  formatumfile: String;
  KettozottVolt: Boolean;

{ ************************************************************** }

function c_sztring(St: String): String;
var
  i: Byte;
  St2: String;
  Eleje: Boolean;
begin
  St2 := '';
  i := Length(St);
  while (St[i] <> '"') and (i<>0) do Dec(St[0]);  { c string vge }
  Eleje := TRUE;
  for i := 1 to Length(St) - 1 do
      case St[i] of
        '\': case St[i+1] of
	          '\': begin St2 := St2 + '\'; Inc(i); end;
                  'n': begin St2 := St2 + #13#10; Inc(i); end;
	          't': begin St2 := St2 + #9; Inc(i); end;
	     else St2 := St2 + St[i];
	     end;
      else
        if not Eleje then St2 := St2 + St[i]
	else if St[i] = '"' then Eleje := FALSE;
      end;
  c_sztring := St2;
end;

procedure Hiba(S: String);
begin
  if IOResult <> 0 then
    begin
      Writeln(S);
      Halt(1);
    end;
end;

procedure Feldolgoz_formatumfajlt(Nev: String);
var
  f: Text;
  St: String;
  o: opciok;
begin
  Writeln('Stilusfajl feldolgozasa...');
  formatumfile := ' -s ' + Nev + ' ';
  Assign(f, Nev);
  {$I-} Reset(f); {$I+}
  if (IOResult <> 0) then begin
  	 writeln( '/home/hega/TeX/mami/'+Nev);
  	 Assign(f, '/home/hega/TeX/mami/'+Nev);
  	 {$I-} Reset(f); {$I+}
  end;
  Hiba('A ' + Nev + ' input allomany nem elerheto!');
  while not Eof(f) do
    begin
      readln(f, St);
      for o := group_skip to heading_suffix do
        if opcio_txt[o] = Copy(St, 1, length(opcio_txt[o])) then
	  opcio[o] := c_sztring(Copy(St, length(opcio_txt[o]), 255));
    end;
  Close(f);
end;

procedure Parameterek;
var
  i: Longint;
  S: String;
 Ok: Boolean;
begin
  Ok := FALSE;
  formatumfile := '';
  for i := 1 to ParamCount do
    begin
      S := ParamStr(i);
      if S[1] = '-' then
         case Upcase(S[2]) of
           '1': Felirat := KISBETUS;
           '2': Felirat := NAGYBETUS;
           '3': Felirat := NAGYONNAGY;
           '?': begin
                  Writeln(Fejlec);
                  Writeln(Sugo);
                  Halt(0);
                end;
	   'S': begin
	          if i < ParamCount then
	            Feldolgoz_formatumfajlt(ParamStr(i+1))
		  else
		    Halt(0);
		  Inc(i);
	        end;
         end
      else
        begin
          FSplit(ParamStr(i), Dir, Nev, Kiterj);
          Ok := TRUE;
        end;
    end;
  if not Ok then
    begin
      Writeln(Fejlec);
      Halt(0);
    end;
end;

procedure InputOutput(Be, Ki: PathStr);
begin
  Assign(Bemenet, Be);
  {$I-} Reset(Bemenet); {$I+}
  Hiba('A ' + Be + ' input allomany nem elerheto!');
  Assign(Kimenet, Ki);
  {$I-} Rewrite(Kimenet); {$I+}
  Hiba('Nem tudom megnyitni a ' + Ki + ' output allomanyt!');
end;

function Kod(BetuKod: Allapot): String;
var
  S: String;
begin
  S := Kodsorozat;
    if BetuKod in SimaABC then
      begin
        if BetuKod in Kisbetuk then S[1] := Kodjel2
          else BetuKod := BetuKod - 44;
        if BetuKod in HosszuMaganhangzok then
          begin
            BetuKod := BetuKod - 1;
            S[3] := Kodjel2;
          end;
        Kod := S + Char(BetuKod + ASCIIfelso);
        Exit;
      end;
    if BetuKod in NagyonNagySimaTobbjegyu then
      begin
        S[3] := Kodjel2;
        Kod := S + TobbjegyubolSima[BetuKod];
        Exit;
      end;
    if BetuKod in KettozottTobbjegyuek then
      begin
        S[2] := Kodjel2;
        if BetuKod in NagyonNagyKettozott then
          S[3] := Kodjel2;
        Kod := S + TobbjegyubolSima[BetuKod] + S + TobbjegyubolSima[BetuKod];
      end;
end;

function Keres(const S: String; i: Longint): Allapot;
var
  j, j2: Allapot;
begin
  Keres := Alapallapot;
  if not (S[i] in ['\', 'A' .. 'Z', 'c', 'd', 'g', 'l', 'n', 't', 's', 'z'])
    then j2 := 44 else j2 := OsszesBetu;
  for j := 1 to j2 do
    if Copy(S, i, Length(LaTeXABC[j])) = LaTeXABC[j] then Keres := j;
end;

procedure Atkodolas(var S: String);
var
  i: Longint;
  B: Allapot;
begin
  S := S + '            ';
  A := AlapAllapot;
  for i := 1 to Length(S) - 12 do
    begin
    if A = ParancsAllapot then
      begin
        if S[i] in ['{', '}', ' ', '[', ']','"'] then A := AlapAllapot;
        Write(Kimenet, S[i]);
      end
    else
      begin
      B := Keres(S, i);
      if B < AlapAllapot then
        begin
          Write(Kimenet, Kod(B));
          i := i + Length(LaTeXABC[B]) - 1;
        end
      else
        if (S[i] = '\') then
          begin
            A := ParancsAllapot;
            Write(Kimenet, S[i]);
          end
         else
            begin
               if (S[i] = '*') and (S[i+1] = '*') then
                  begin
                    Write(Kimenet, S[i+2]);
                    i := i + 2;
                  end
                else Write(Kimenet, S[i]);
            end;
         end;
      end;
end;

procedure Feldolgozas;
var
    S: String;
  Sor: Longint;
begin
  Sor := 1;
  InputOutput(Dir + Nev + '.idx', Dir + Nev + '.id2');
  Write('Kodolas folyamatban');
  while not Eof(Bemenet) do
    begin
      Readln(Bemenet, S);
      Atkodolas(S);
      Sor := Sor + 1;
      if Sor mod 10 = 0 then Write('.');
      Writeln(Kimenet);
    end;
  Close(Bemenet);
  Close(Kimenet);
  Writeln;
end;

{ ************************************************************** }

procedure MakeIndex;
var
  PRG: String;
begin
  Writeln('makeindex meghivasa...');
  PRG := FExpand(FSearch(makename, GetEnv('PATH')));
  SwapVectors;
  Exec(PRG, formatumfile + '-l -o ' + Dir + Nev + '.in2' + 
       ' ' + Dir + Nev + '.id2');
  SwapVectors;
  if DosError <> 0 then
    begin
      Writeln('A makeindex hivasa sikertelen volt.');
      Halt(1);
    end;
end;

{ ************************************************************** }

function HanyadikTobbjegyuBetu(Jel: Char): Byte;
var
  i : Byte;
begin
  i := 89;
  while Jel <> TobbjegyubolSima[i] do i := i + 1;
  HanyadikTobbjegyuBetu := i;
end;


function Jel2Betu(NagyBetu, Kettozott, HosszuVagyNagyonNagy:
Boolean;
  Jel: Byte): Allapot;
begin
  if (Jel - ASCIIfelso) in TobbjegyuMassalhangzok then
  begin
    if NagyBetu and (not Kettozott) and HosszuVagyNagyonNagy then
      Jel := HanyadikTobbjegyuBetu(Char(Jel));
    if Kettozott then
      begin
        if KettozottVolt then
          begin
            KettozottVolt := FALSE;
            Jel2Betu := 0;
            Exit;
          end;
        KettozottVolt := TRUE;
        Jel := HanyadikTobbjegyuBetu(Char(Jel)) + 9;
        if HosszuVagyNagyonNagy then Jel := Jel + 9;
      end;
    if (not Kettozott) and (not HosszuVagyNagyonNagy) then
      begin
        Jel := Jel - ASCIIfelso;
        if NagyBetu then Jel := Jel + 44;
      end;
  end
  else
    begin
      Jel := Jel - ASCIIfelso;
      if NagyBetu then Jel := Jel + 44;
      if HosszuVagyNagyonNagy then Jel := Jel + 1;
    end;
  Jel2Betu := Jel;
end;


function Betu2Cim(Betu: Allapot): String;
begin
  if Felirat = KISBETUS then Betu2Cim := LaTeXABC[Betu]
  else
    if Felirat = NAGYBETUS then Betu2Cim := LaTeXABC[Betu + 44]
    else
    begin
      if Betu in TobbjegyuMassalhangzok then
         Betu2Cim := LaTeXABC[HanyadikTobbjegyuBetu(Char(Betu + ASCIIfelso))]
      else Betu2Cim := LaTeXABC[Betu + 44];
    end;
end;

procedure KiirFelirat(ElozoBetu, Q: Byte);
const
  Szoveg: String = '';
begin
  if ElozoBetu <> Q then
  begin
    Writeln(Kimenet, opcio[group_skip]);
    if Felirat <> NINCS then
      begin
        Q := Q - ASCIIfelso;
        if (Q > 0) and (Q <= 44) then
        begin
          Szoveg := Betu2Cim(Q);
          if ((Q + 1) in HosszuMaganhangzok) then
             Szoveg := Szoveg + ', ' + Betu2Cim(Q + 1);
          Write(Kimenet, opcio[heading_prefix] + Szoveg + opcio[heading_suffix]);
        end;
      end;
  end;
end;

function NemSub(S: String): Boolean;
var
  i: Longint;
begin
  NemSub := FALSE;
  if Length(S) > 5 then
    for i := 1 to Length(S) - 5 do
      if Copy(S, i, 5) = '\item' then
begin NemSub := TRUE; Exit; end;
end;

procedure Visszakonvertalas;
const
  UjSor: Boolean = TRUE;
  RejtettMinta: Boolean = FALSE;
  A: Allapot = 0;
  S: String = '';
  ElozoSor: String = '';
{  ElozoBetu: Char = #0;
 }
var
  Q: array [0 .. 3] of Char;
  i: Longint;
  ElozoBetu: Char;
begin
  ElozoBetu := #0;
  Writeln('Visszakonvertalas folyamatban...');
  KettozottVolt := FALSE;
  InputOutput(Dir + Nev + '.in2', Dir + Nev + '.ind');
  Writeln(Kimenet, '\providecommand{\IeC}{}');
  while not Eof(Bemenet) do
    begin
      Read(Bemenet, Q[A]);
      if RejtettMinta and (Q[A] = ' ') then RejtettMinta := FALSE;
      if Upcase(Q[A]) = KodJel then
        begin
          A := A + 1;
          if A = 3 then
            begin
              Read(Bemenet, Q[A]);
              if UjSor then
                begin
                  Write(Kimenet, ElozoSor);
                  if NemSub(S) then
                    begin
                       KiirFelirat(Byte(ElozoBetu), Byte(Q[3]));
                       ElozoBetu := Q[3];
                    end;
                  UjSor := FALSE;
                end;
              if not RejtettMinta then
                 S := S + LaTeXABC[Jel2Betu(Q[0] = KodJel,
                      Q[1] <> KodJel, Q[2] <> KodJel, Byte(Q[3]))];
              A := 0;
            end;
        end
      else
        begin
          if not RejtettMinta then for i := 0 to A do S := S + Q[i];
          if (S[Length(S)] = '*') and (S[Length(S)-1] = '*') then
             S[0] := Char(Length(S)-2);
          if (S[Length(S)] = '&') and (S[Length(S)-1] = '&') then
             begin
               S[0] := Char(Length(S)-2);
               RejtettMinta := TRUE;
             end;
          A := 0;
        end;
     if Eoln(Bemenet) then
       begin
         if UjSor then Write(Kimenet, ElozoSor) else UjSor := TRUE;
         ElozoSor := S;
         S := '';
        end;
    end;
  close(Bemenet);
  close(Kimenet);
end;

{ ************************************************************** }

begin
  Writeln(verzio);
  Parameterek;
  if Kiterj <> '.in2' then
    begin
      Feldolgozas;
      MakeIndex;
    end;
  Visszakonvertalas;
end.

